# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    # Declaring local variables
    app_uninstallstring = makepath(programfiles32, "Bitvise SSH Client", "uninst.exe")
    app_uninstallkey = "BvSshClient"

    # Installing the software
    print("Installing: BvSshClient-Inst.exe")
    install_exe_if_needed('BvSshClient-Inst.exe',
        silentflags='/acceptEULA',
        key='BvSshClient',
        min_version=control.get_software_version(),
    )
    #Adding QuietUninstallString
    quiet_uninstall_string = rf'"{app_uninstallstring}" -unat BvSshClient'
    register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)

    uninstallkey.clear()


def uninstall():
    # Force uninstalling the software
    for to_uninstall in installed_softwares(name="Bitvise SSH Client"):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))

        try:
            # Adding silent flags to the uninstall command
            uninstall_command = uninstall_cmd(to_uninstall["key"])
            print(uninstall_command)
            run(uninstall_command)
            wait_uninstallkey_absent(to_uninstall["key"], max_loop=60)
        except Exception as e:
            print(f"Error during uninstallation: {e}")
            # Handling the case where Bitvise SSH Clien Director might already be partially uninstalled
            print("Bitvise SSH Clien Director might have already been uninstalled.")
            print("Removing Bitvise SSH Clien Director from the list of installed programs.")

        if uninstall_key_exists(to_uninstall["key"]):
            unregister_uninstall(to_uninstall["key"], win64app=to_uninstall["win64"])

        # Clean up any remaining files
        if isdir(to_uninstall["install_location"]):
            print(f"Removing remaining files in {to_uninstall['install_location']}")
            remove_tree(to_uninstall["install_location"])

